﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using GrapeCity.Windows.SpreadSheet.Data;
using GrapeCity.Windows.SpreadSheet.UI ;
using GrapeCity.Windows.SpreadSheet.UI.UndoRedo; 
namespace UndowithSpreadSL_CS
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            var sheet = this.gcSpreadSheet1.ActiveSheet;
            sheet.RowCount = 20;
            sheet.ColumnCount = 10;
            for (int i = 0; i < sheet.RowCount; i++)
            {
                for (int j = 0; j < sheet.ColumnCount; j++)
                {
                    sheet.SetValue(i, j, i + j);
                }
            }            
        }
        private void button1_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpreadSheet1.UndoManager.Do(new AddRowsUndo(2, 3));
        }
        private void button2_Click(object sender, RoutedEventArgs e)
        {
            this.gcSpreadSheet1.UndoManager.Do(new RemoveRowsUndo(3, 2));
        }
    }
    public class AddRowsUndo : ActionBase, IUndo
    {
        int _row;
        int _rowCount;
        public AddRowsUndo(int row, int rowCount)
        {
            _row = row;
            _rowCount = rowCount;
        }
        public bool CanUndo
        {
            get { return true; }
        }
        public void SaveState()
        {

        }
        public bool Undo(object parameter)
        {
            try
            {
                var sheet = (parameter as SpreadView).ActiveSheet;
                sheet.RemoveRows(_row, _rowCount);
            }
            catch { return false; }
            return true;
        }
        public override bool CanExecute(object parameter)
        {
            return true;
        }
        public override void Execute(object parameter)
        {
            var sheet = (parameter as SpreadView).ActiveSheet;
            sheet.AddRows(_row, _rowCount);
        }
    }
    public class RemoveRowsUndo : ActionBase, IUndo
    {
        int _row;
        int _rowCount;
        ClearValueUndoAction _clearValueAction;
        public RemoveRowsUndo(int row, int rowCount)
        {
            _row = row;
            _rowCount = rowCount;
        }
        public bool CanUndo
        {
            get { return true; }
        }
        public void SaveState()
        {

        }
        public bool Undo(object parameter)
        {
            try
            {
                var sheet = (parameter as SpreadView).ActiveSheet;
                sheet.AddRows(_row, _rowCount);
                this._clearValueAction.Undo(parameter);
            }
            catch { return false; }
            return true;
        }
        public override bool CanExecute(object parameter)
        {
            return true;
        }
        public override void Execute(object parameter)
        {
            var sheet = (parameter as SpreadView).ActiveSheet;
            this._clearValueAction = new ClearValueUndoAction(sheet, new CellRange[] { new CellRange(_row, -1, _rowCount, -1) });
            this._clearValueAction.Execute(parameter);
            sheet.RemoveRows(_row, _rowCount);
        }

    }
}
